<?php

declare(strict_types=1);

namespace DoctrineMigrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20210806124110 extends AbstractMigration
{
    public function getDescription(): string
    {
        return 'import countries';
    }

    public function up(Schema $schema): void
    {
        $dataDirectory = dirname(__FILE__, 2).'/data';
        $countries = json_decode(file_get_contents($dataDirectory.'/countries.json'));
        foreach ($countries as $country) {
            $this->addSql('INSERT INTO country (id, name, locale_name, code) VALUES (:id, :name, :localeName, :code)', [
                'id' => $country->id,
                'name' => $country->name,
                'localeName' => $country->localeName,
                'code' => $country->code,
            ]);
        }
        $states = json_decode(file_get_contents($dataDirectory.'/states.json'));
        foreach ($states as $state) {
            $this->addSql('INSERT INTO country_region (id, name, code, country_id) VALUES (:id, :name, :code, :country)', [
                'id' => $state->id,
                'name' => $state->name,
                'code' => $state->code,
                'country' => $state->countryId,
            ]);
        }
    }

    public function down(Schema $schema): void
    {
        $this->addSql('TRUNCATE country');
        $this->addSql('TRUNCATE country_region');
    }
}
