import { Injectable } from '@angular/core';
import { MatSnackBar } from '@angular/material/snack-bar';

enum NotificationType {
    Success,
    Error,
    Info,
}

@Injectable()
export class NotificationService {

    constructor(private snackBar: MatSnackBar) { }

    notify(type: NotificationType, title: string): void {
        let action: string;
        let panelClass: string;
        const duration = 1500000;

        switch (type) {
            case NotificationType.Success:
                action = 'OK';
                panelClass = 'notify-success';
                break;

            case NotificationType.Error:
                action = 'OK';
                panelClass = 'notify-error';
                break;
        }

        this.snackBar.open(title, action, {
            panelClass,
            duration,
        });
    }

    success(title: string): void {
        return this.notify(NotificationType.Success, title);
    }

    error(title: string): void {
        return this.notify(NotificationType.Error, title);
    }

}
